package swt.draw;

/**Testflle fr die Visitor.
 * Anmerkung: die Methoden knnen allesamt als Unit-Tests umgesetzt werden: Referenz auf das JUnit-Framework zufgen
 * und die Test-Methoden mit der Annotation "@Test" versehen.
 * Innerhalb der Testmethode die "if"-Bedingungen rauswerfen und durch die aktuell auskommentierten "assertEquals"-Aufrufe ersetzen.
 *
 */
public class Tests {
	
  public static void main(String[] args) 
  {
    //Tests durchfhren:
    Tests tests = new Tests();
    
    tests.NullRectangle();
    tests.EinRectangle();
    tests.ZweiRectangle();
    
    tests.NullLines();
    tests.EineLines();
    tests.ZweiLines();
  }
	
	// Rectangle test
	public void NullRectangle() 
	{
	  CountRectangle count = new CountRectangle();
	  
		Container c = new Container();
		c.accept(count);
		//assertEquals(0, count.countRectangle());
		if (count.countRectangle() != 0)
		{
		  System.err.println("NullRectangle: Nicht genau 0 Rechtecke gezhlt: " + count.countRectangle());
		}
		else
		{
		  System.out.println("NullRectangle: OK");
		}
	}
	
	public void EinRectangle() 
	{
	  CountRectangle count = new CountRectangle();
	  
		Container c = new Container();
		Rectangle r = new Rectangle(100, 150, 200, 250);
		c.add(r);
		c.accept(count);
		//assertEquals(1,count.countRectangle());
		if (count.countRectangle() != 1)
    {
      System.err.println("EinRectangle: Nicht genau 1 Rechteck gezhlt: " + count.countRectangle());
    }
    else
    {
      System.out.println("EinRectangle: OK");
    }
	}

	public void ZweiRectangle() 
	{
	  CountRectangle count = new CountRectangle();
	  
		Container c = new Container();
		Rectangle r1 = new Rectangle(100, 150, 200, 250);
		Rectangle r2 = new Rectangle(100, 150, 200, 250);
		c.add(r2);
		c.add(r1);
		c.accept(count);
		//assertEquals(2,count.countRectangle());
		if (count.countRectangle() != 2)
    {
      System.err.println("ZweiRectangle: Nicht genau 2 Rechtecke gezhlt: " + count.countRectangle());
    }
    else
    {
      System.out.println("ZweiRectangle: OK");
    }
	}
	
	
	//Lines tests
	public void NullLines() 
	{
	  GetLines gl = new GetLines();
	  
		Container c = new Container();
		c.accept(gl);
		//assertEquals(0, gl.getLine().size());
		if (gl.getLine().size() != 0)
    {
      System.err.println("NullLines: Nicht genau 0 Linien gezhlt: " + gl.getLine().size());
    }
    else
    {
      System.out.println("NullLines: OK");
    }
	}
	
	
	public void EineLines() 
	{
	  GetLines gl = new GetLines();
	  
		Container c = new Container();
		Line l = new Line(100, 150, 200, 250);
		c.add(l);
		c.accept(gl);
		//assertEquals(1,gl.getLine().size());
		if (gl.getLine().size() != 1)
    {
      System.err.println("EineLines: Nicht genau 1 Linien gezhlt: " + gl.getLine().size());
    }
    else
    {
      System.out.println("EineLines: OK");
    }
	}

	public void ZweiLines() 
	{
	  GetLines gl = new GetLines();
	  
		Container c = new Container();
		Line l1 = new Line(100, 150, 200, 250);
		Line l2 = new Line(100, 150, 200, 250);
		c.add(l1);
		c.add(l2);
		c.accept(gl);
		//assertEquals(2,gl.getLine().size());
		if (gl.getLine().size() != 2)
    {
      System.err.println("EineLines: Nicht genau 2 Linien gezhlt: " + gl.getLine().size());
    }
    else
    {
      System.out.println("EineLines: OK");
    }
	}
	
}
